unit UnitFrameGestureEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, UnitFrmMouseMonitor;

type
  TFrameGestureEdit = class(TFrame)
    Label1: TLabel;
    txtGesture: TEdit;
    btnUP: TSpeedButton;
    btnDown: TSpeedButton;
    btnRight: TSpeedButton;
    btnLeft: TSpeedButton;
    btnNE: TSpeedButton;
    btnSE: TSpeedButton;
    btnSW: TSpeedButton;
    btnNW: TSpeedButton;
    btnClear: TButton;
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnLeftClick(Sender: TObject);
    procedure btnRightClick(Sender: TObject);
    procedure btnUPClick(Sender: TObject);
    procedure btnDownClick(Sender: TObject);
    procedure btnNEClick(Sender: TObject);
    procedure btnSEClick(Sender: TObject);
    procedure btnSWClick(Sender: TObject);
    procedure btnNWClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
  private
    { Private declarations }
    gesture : string;
    procedure Append(md : TMouseDirection);
    procedure EnableButtons;
  public
    { Public declarations }
    function GetGesture(var name : string; var gesture : string) : boolean;
    procedure Init;
  end;

var
  FrameGestureEdit: TFrameGestureEdit;

implementation

uses StrUtils, UnitFrmGestures;
{$R *.dfm}

procedure TFrameGestureEdit.Append(md : TMouseDirection);
var s : string;
begin
    if txtGesture.Text <> '' then txtGesture.text := txtGesture.text + '+';
    txtGesture.text := txtGesture.text + Uppercase(FrmMouseMonitor.ToString(md));
    s := IntToStr(Integer(md));
    gesture := gesture + s;
    //bSet.Enabled := true;
end;

procedure TFrameGestureEdit.EnableButtons;
begin
    btnUP.Enabled := true;
    btnDown.Enabled := true;
    btnLeft.Enabled := true;
    btnRight.Enabled := true;

    if FrmMouseMonitor.prEnableDiagonals then begin
        btnNE.Visible := true;
        btnNW.Visible := true;
        btnSE.Visible := true;
        btnSW.Visible := true;
    end else begin
        btnNE.Visible := false;
        btnNW.Visible := false;
        btnSE.Visible := false;
        btnSW.Visible := false;
    end;
    btnNE.Enabled := true;
    btnNW.Enabled := true;
    btnSE.Enabled := true;
    btnSW.Enabled := true;
end;

procedure TFrameGestureEdit.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (KEY = VK_ESCAPE) then begin
        //self.bCancel.Click;
    end;
end;

function TFrameGestureEdit.GetGesture(var name : string; var gesture: string): boolean;
begin
    //bSet.Enabled := false;
    //self.gesture := '';
    //txtGesture.Text := '';
    //self.EnableButtons;
    //self.ShowModal;

    //result := self.ModalResult = mrOk;
    //if result then begin
        name := txtGesture.Text;
        gesture := self.gesture;
    //end;

end;

procedure TFrameGestureEdit.Init;
begin
    btnClear.Click;
end;

procedure TFrameGestureEdit.btnUPClick(Sender: TObject);
begin
    Append( mdUp );
    EnableButtons;
    btnUp.Enabled := false;
    btnNE.Enabled := false;
    btnNW.Enabled := false;
end;

procedure TFrameGestureEdit.btnClearClick(Sender: TObject);
begin
    txtGesture.Text := '';
    gesture := '';
    self.EnableButtons;
end;

procedure TFrameGestureEdit.btnDownClick(Sender: TObject);
begin
    Append( mdDown) ;
    EnableButtons;
    btnDown.Enabled := false;
    btnSE.Enabled := false;
    btnSW.Enabled := false;

end;

procedure TFrameGestureEdit.btnRightClick(Sender: TObject);
begin
    Append( mdRight );
    EnableButtons;
    btnRight.Enabled := false;
    btnNE.Enabled := false;
    btnSE.Enabled := false;
end;

procedure TFrameGestureEdit.btnSEClick(Sender: TObject);
begin
    Append( mdSE );
    EnableButtons;
    btnDown.Enabled := false;
    btnSE.Enabled := false;
    //btnSW.Enabled := false;
    btnRight.Enabled := false;
end;

procedure TFrameGestureEdit.btnSWClick(Sender: TObject);
begin
    Append( mdSW );
    EnableButtons;
    btnDown.Enabled := false;
    //btnSE.Enabled := false;
    btnSW.Enabled := false;
    btnLeft.Enabled := false;
end;

procedure TFrameGestureEdit.btnLeftClick(Sender: TObject);
begin
    Append( mdLeft );
    EnableButtons;
    btnLeft.Enabled := false;
    btnNW.Enabled := false;
    btnSW.Enabled := false;
end;

procedure TFrameGestureEdit.btnNEClick(Sender: TObject);
begin
    Append( mdNE );
    EnableButtons;
    btnUp.Enabled := false;
    btnNE.Enabled := false;
    //btnNW.Enabled := false;
    btnRight.Enabled := false;
end;

procedure TFrameGestureEdit.btnNWClick(Sender: TObject);
begin
    Append( mdNW );
    EnableButtons;
    btnUp.Enabled := false;
    //btnNE.Enabled := false;
    btnNW.Enabled := false;
    btnLeft.Enabled := false;
end;

end.
